import React, { useState, useRef } from 'react';
import PropTypes from 'prop-types';
import { usePicker } from './context';
import { getHandleValue } from './utils';
import { usePaintSat, usePaintLight, usePaintBright } from './usePaintHue';
var tinycolor = require("tinycolor2");
var AdvancedControls = function (_a) {
    var openAdvanced = _a.openAdvanced;
    var _b = usePicker(), tinyColor = _b.tinyColor, hue = _b.hue, l = _b.l, handleChange = _b.handleChange, s = _b.s, opacity = _b.opacity;
    var _c = tinyColor.toHsv(), v = _c.v, vs = _c.s;
    var satRef = useRef(null);
    var lightRef = useRef(null);
    var brightRef = useRef(null);
    usePaintSat(satRef, hue, l * 100);
    usePaintLight(lightRef, hue, s * 100);
    usePaintBright(brightRef, hue, s * 100);
    var satDesat = function (value) {
        var _a = tinycolor({ h: hue, s: value / 100, l: l }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setLight = function (value) {
        var _a = tinycolor({ h: hue, s: s, l: value / 100 }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setBright = function (value) {
        var _a = tinycolor({ h: hue, s: vs * 100, v: value }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    return (React.createElement("div", { style: { height: openAdvanced ? 154 : 0, width: '100%', transition: 'all 120ms linear' } },
        React.createElement("div", { style: { paddingTop: 11, display: openAdvanced ? '' : 'none' } },
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3, marginBottom: -2 } }, "Saturation"),
            React.createElement(AdvBar, { left: s * 276, reffy: satRef, callback: satDesat }),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 8, marginBottom: -2 } }, "Lightness"),
            React.createElement(AdvBar, { left: l * 276, reffy: lightRef, callback: setLight }),
            React.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 8, marginBottom: -2 } }, "Brightness"),
            React.createElement(AdvBar, { left: v * 276, reffy: brightRef, callback: setBright }))));
};
export default AdvancedControls;
var AdvBar = function (_a) {
    var left = _a.left, callback = _a.callback, reffy = _a.reffy;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            callback(getHandleValue(e));
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            callback(getHandleValue(e));
        }
    };
    return (React.createElement("div", { className: 'bar-wrap', onMouseEnter: stopDragging, onMouseLeave: stopDragging },
        React.createElement("div", { className: 'ps-rl bar-wrap-inner', onMouseUp: stopDragging },
            React.createElement("div", { className: 'c-resize ps-rl', onMouseMove: function (e) { return handleMove(e); }, style: { width: 294, height: 14, borderRadius: 10 } },
                React.createElement("div", { style: { left: left, top: -0.5 }, className: 'handle', onMouseDown: function () { return setDragging(true); } }),
                React.createElement("canvas", { ref: reffy, width: '294px', height: '14px', style: { position: 'relative', borderRadius: 14 }, onClick: function (e) { return handleClick(e); } })))));
};
AdvancedControls.propTypes = {
    openAdvanced: PropTypes.bool,
};
//# sourceMappingURL=AdvancedControls.js.map