import React, { useState } from "react";
import { getHandleValue } from './utils';
import { usePicker } from "./context";
import PropTypes from 'prop-types';
var GradientBar = function () {
    var _a = usePicker(), currentColor = _a.currentColor, addPoint = _a.addPoint, colors = _a.colors, value = _a.value, handleGradient = _a.handleGradient;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    var stopDragging = function () {
        setDragging(false);
    };
    var handleDown = function (e) {
        if (!dragging) {
            addPoint(e);
        }
    };
    var handleMove = function (e) {
        if (dragging) {
            handleGradient(currentColor, getHandleValue(e));
        }
    };
    return (React.createElement("div", { className: 'bar-wrap', onMouseEnter: stopDragging, onMouseLeave: stopDragging },
        React.createElement("div", { className: 'ps-rl bar-wrap-inner', onMouseUp: stopDragging },
            React.createElement("div", { onMouseDown: function (e) { return handleDown(e); }, onMouseMove: function (e) { return handleMove(e); }, style: { paddingTop: 6, paddingBottom: 6 } },
                React.createElement("div", { style: { width: 294, height: 14, backgroundImage: value, borderRadius: 10 } })), colors === null || colors === void 0 ? void 0 :
            colors.map(function (c, i) { return (React.createElement(Handle, { left: c.left, key: "".concat(i, "-").concat(c), i: i, setDragging: setDragging })); }))));
};
export default GradientBar;
export var Handle = function (_a) {
    var left = _a.left, i = _a.i, setDragging = _a.setDragging;
    var _b = usePicker(), setSelectedColor = _b.setSelectedColor, selectedColor = _b.selectedColor;
    var isSelected = selectedColor === i;
    var handleDown = function (e) {
        e.stopPropagation();
        setSelectedColor(i);
        setDragging(true);
    };
    return (React.createElement("div", { style: { left: left * 2.76 + 13 }, onMouseDown: function (e) { return handleDown(e); }, className: 'gradient-handle-wrap' },
        React.createElement("div", { style: handleStyle(isSelected), className: 'gradient-handle df jc ac' }, isSelected && React.createElement("div", { style: { width: 5, height: 5, borderRadius: '50%', background: 'white' } }))));
};
var handleStyle = function (isSelected) {
    return {
        boxShadow: isSelected ? '0px 0px 5px 1px rgba(86, 140, 245,.95)' : '',
        border: isSelected ? '2px solid white' : '2px solid rgba(255,255,255,.75)',
    };
};
Handle.propTypes = {
    left: PropTypes.number,
    i: PropTypes.number,
    setDragging: PropTypes.func,
};
//# sourceMappingURL=GradientBar.js.map