import { __assign } from "tslib";
import React from 'react';
import { usePicker } from './context';
import { formatInputValues } from './formatters';
import { controlBtnStyles } from './Controls';
import TrashIcon, { LinearIcon, RadialIcon, DegreesIcon, StopIcon } from './icon';
var GradientControls = function () {
    var gradientType = usePicker().gradientType;
    return (React.createElement("div", { className: 'df jsb', style: { marginTop: 12, marginBottom: -4, background: '#e9e9f5', borderRadius: 6 } },
        React.createElement(GradientType, null),
        React.createElement("div", { style: { width: 53 } }, gradientType === 'linear-gradient' && React.createElement(DegreePicker, null)),
        React.createElement(StopPicker, null),
        React.createElement(DeleteBtn, null)));
};
export default GradientControls;
var GradientType = function () {
    var _a = usePicker(), gradientType = _a.gradientType, onChange = _a.onChange, value = _a.value;
    var isLinear = gradientType === 'linear-gradient';
    var isRadial = gradientType === 'radial-gradient';
    var handleLinear = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(90deg, ".concat(remaining));
    };
    var handleRadial = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("radial-gradient(circle, ".concat(remaining));
    };
    return (React.createElement("div", { className: 'df ac control-btns-wrap' },
        React.createElement("div", { className: 'control-btn', onClick: handleLinear, style: __assign({}, controlBtnStyles(isLinear)) },
            React.createElement(LinearIcon, { color: isLinear ? '#568CF5' : '' })),
        React.createElement("div", { className: 'control-btn', onClick: handleRadial, style: __assign({}, controlBtnStyles(isRadial)) },
            React.createElement(RadialIcon, { color: isRadial ? '#568CF5' : '' }))));
};
var StopPicker = function () {
    var _a = usePicker(), currentLeft = _a.currentLeft, handleGradient = _a.handleGradient, currentColor = _a.currentColor;
    var handleMove = function (newVal) {
        handleGradient(currentColor, formatInputValues(newVal, 0, 100));
    };
    return (React.createElement("div", { className: 'df ac control-btns-wrap', style: { paddingLeft: 8 } },
        React.createElement(StopIcon, null),
        React.createElement("input", { className: 'degree-input', value: currentLeft, onChange: function (e) { return handleMove(e.target.value); } })));
};
var DegreePicker = function () {
    var _a = usePicker(), degrees = _a.degrees, onChange = _a.onChange, value = _a.value;
    var handleDegrees = function (e) {
        var newValue = formatInputValues(e.target.value, 0, 360);
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(".concat(newValue || 0, "deg, ").concat(remaining));
    };
    return (React.createElement("div", { className: 'ps-rl control-btns-wrap df ac' },
        React.createElement(DegreesIcon, null),
        React.createElement("input", { className: 'degree-input', value: degrees, onChange: function (e) { return handleDegrees(e); } }),
        React.createElement("div", { style: { position: 'absolute', right: degrees > 99 ? 0 : degrees < 10 ? 7 : 3, top: 1, fontWeight: 400, fontSize: 13 } }, "\u00B0")));
};
var DeleteBtn = function () {
    var deletePoint = usePicker().deletePoint;
    return (React.createElement("div", { onClick: deletePoint, className: 'df jc ac control-btns-wrap', style: __assign(__assign({ width: 30 }, controlBtnStyles(false)), { marginRight: 1 }) },
        React.createElement(TrashIcon, null)));
};
//# sourceMappingURL=GradientControls.js.map