import React, { useRef, useState } from "react";
import throttle from "lodash.throttle";
import usePaintSquare from "./usePaintSquare";
import { usePicker } from './context';
var Square = function () {
    var _a = usePicker(), handleColor = _a.handleColor, x = _a.x, y = _a.y, internalHue = _a.internalHue;
    var _b = useState(false), dragging = _b[0], setDragging = _b[1];
    var canvas = useRef(null);
    usePaintSquare(canvas, internalHue);
    var handleChange = function (e) {
        var _a;
        var ctx = (_a = canvas === null || canvas === void 0 ? void 0 : canvas.current) === null || _a === void 0 ? void 0 : _a.getContext("2d");
        var onMouseMove = throttle(function () { return handleColor(e, ctx); }, 250);
        onMouseMove();
    };
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            handleChange(e);
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            handleChange(e);
        }
    };
    return (React.createElement("div", { className: 'ps-rl' },
        React.createElement("div", { style: { position: 'absolute', left: -7, top: -7, width: 308, height: 308 }, onMouseEnter: stopDragging }),
        React.createElement("div", { className: 'ps-rl c-cross', onMouseMove: function (e) { return handleMove(e); }, onMouseUp: stopDragging },
            React.createElement("div", { style: { left: x, top: y }, className: 'handle', onMouseDown: function () { return setDragging(true); } }),
            React.createElement("div", { className: 'canvas-wrapper', onClick: function (e) { return handleClick(e); } },
                React.createElement("canvas", { ref: canvas, width: '294px', height: '294px', id: 'paintSquare' })))));
};
export default Square;
//# sourceMappingURL=Square.js.map