import { config } from './constants';
import { gradientParser } from './gradientParser';
var defaultColor = config.defaultColor, defaultGradient = config.defaultGradient;
export var low = function (color) {
    return color.value.toLowerCase();
};
export var high = function (color) {
    return color.value.toUpperCase();
};
export var getColors = function (value) {
    var isGradient = value === null || value === void 0 ? void 0 : value.includes('gradient');
    if (isGradient) {
        var isConic = value === null || value === void 0 ? void 0 : value.includes('conic');
        var safeValue = !isConic && validate(value) ? value : defaultGradient;
        if (isConic) {
            console.log('Sorry we cant handle conic gradients yet');
        }
        var obj = gradientParser(safeValue);
        return obj === null || obj === void 0 ? void 0 : obj.colorStops;
    }
    else {
        var safeValue = validate(value) ? value : defaultColor;
        return [{ value: safeValue }];
    }
};
var validate = function (c) {
    var img = document.createElement('img');
    img.style = 'background: rgb(0, 0, 0)';
    img.style = 'background: ' + c;
    if (img.style.background !== 'rgb(0, 0, 0)' && img.style.background !== '')
        return true;
    img.style = 'background: rgb(255, 255, 255)';
    img.style = 'background: ' + c;
    return (img.style.background !== 'rgb(255, 255, 255)' && img.style.background !== '');
};
export var formatInputValues = function (value, min, max) {
    return isNaN(value) ? min : value < min ? min : value > max ? max : value;
};
//# sourceMappingURL=formatters.js.map