import { useEffect } from "react";
import { config } from './constants';
var squareSize = config.squareSize;
var usePaintSquare = function (canvas, hue) {
    useEffect(function () {
        var ctx = canvas.current.getContext("2d");
        ctx.fillStyle = "hsl(".concat(hue, ", 100%, 50%)");
        ctx.fillRect(0, 0, squareSize, squareSize);
        var gradientWhite = ctx.createLinearGradient(0, 0, squareSize, 0);
        gradientWhite.addColorStop(0, "rgba(255, 255, 255, 1)");
        gradientWhite.addColorStop(1, "rgba(255, 255, 255, 0)");
        ctx.fillStyle = gradientWhite;
        ctx.fillRect(0, 0, squareSize, squareSize);
        var gradientBlack = ctx.createLinearGradient(0, 0, 0, squareSize);
        gradientBlack.addColorStop(0, "rgba(0, 0, 0, 0)");
        gradientBlack.addColorStop(1, "rgba(0, 0, 0, 1)");
        ctx.fillStyle = gradientBlack;
        ctx.fillRect(0, 0, squareSize, squareSize);
    }, [canvas, hue]);
};
export default usePaintSquare;
//# sourceMappingURL=usePaintSquare.js.map