"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var prop_types_1 = tslib_1.__importDefault(require("prop-types"));
var context_1 = require("./context");
var utils_1 = require("./utils");
var usePaintHue_1 = require("./usePaintHue");
var tinycolor = require("tinycolor2");
var AdvancedControls = function (_a) {
    var openAdvanced = _a.openAdvanced;
    var _b = (0, context_1.usePicker)(), tinyColor = _b.tinyColor, hue = _b.hue, l = _b.l, handleChange = _b.handleChange, s = _b.s, opacity = _b.opacity;
    var _c = tinyColor.toHsv(), v = _c.v, vs = _c.s;
    var satRef = (0, react_1.useRef)(null);
    var lightRef = (0, react_1.useRef)(null);
    var brightRef = (0, react_1.useRef)(null);
    (0, usePaintHue_1.usePaintSat)(satRef, hue, l * 100);
    (0, usePaintHue_1.usePaintLight)(lightRef, hue, s * 100);
    (0, usePaintHue_1.usePaintBright)(brightRef, hue, s * 100);
    var satDesat = function (value) {
        var _a = tinycolor({ h: hue, s: value / 100, l: l }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setLight = function (value) {
        var _a = tinycolor({ h: hue, s: s, l: value / 100 }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    var setBright = function (value) {
        var _a = tinycolor({ h: hue, s: vs * 100, v: value }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
    };
    return (react_1.default.createElement("div", { style: { height: openAdvanced ? 154 : 0, width: '100%', transition: 'all 120ms linear' } },
        react_1.default.createElement("div", { style: { paddingTop: 11, display: openAdvanced ? '' : 'none' } },
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 3, marginBottom: -2 } }, "Saturation"),
            react_1.default.createElement(AdvBar, { left: s * 276, reffy: satRef, callback: satDesat }),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 8, marginBottom: -2 } }, "Lightness"),
            react_1.default.createElement(AdvBar, { left: l * 276, reffy: lightRef, callback: setLight }),
            react_1.default.createElement("div", { style: { textAlign: 'center', color: '#323136', fontSize: 12, fontWeight: 500, marginTop: 8, marginBottom: -2 } }, "Brightness"),
            react_1.default.createElement(AdvBar, { left: v * 276, reffy: brightRef, callback: setBright }))));
};
exports.default = AdvancedControls;
var AdvBar = function (_a) {
    var left = _a.left, callback = _a.callback, reffy = _a.reffy;
    var _b = (0, react_1.useState)(false), dragging = _b[0], setDragging = _b[1];
    var stopDragging = function () {
        setDragging(false);
    };
    var handleMove = function (e) {
        if (dragging) {
            callback((0, utils_1.getHandleValue)(e));
        }
    };
    var handleClick = function (e) {
        if (!dragging) {
            callback((0, utils_1.getHandleValue)(e));
        }
    };
    return (react_1.default.createElement("div", { className: 'bar-wrap', onMouseEnter: stopDragging, onMouseLeave: stopDragging },
        react_1.default.createElement("div", { className: 'ps-rl bar-wrap-inner', onMouseUp: stopDragging },
            react_1.default.createElement("div", { className: 'c-resize ps-rl', onMouseMove: function (e) { return handleMove(e); }, style: { width: 294, height: 14, borderRadius: 10 } },
                react_1.default.createElement("div", { style: { left: left, top: -0.5 }, className: 'handle', onMouseDown: function () { return setDragging(true); } }),
                react_1.default.createElement("canvas", { ref: reffy, width: '294px', height: '14px', style: { position: 'relative', borderRadius: 14 }, onClick: function (e) { return handleClick(e); } })))));
};
AdvancedControls.propTypes = {
    openAdvanced: prop_types_1.default.bool,
};
//# sourceMappingURL=AdvancedControls.js.map