"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.controlBtnStyles = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var icon_1 = require("./icon");
var context_1 = require("./context");
var react_color_eye_dropper_1 = tslib_1.__importDefault(require("react-color-eye-dropper"));
var constants_1 = require("./constants");
var AdvancedControls_1 = tslib_1.__importDefault(require("./AdvancedControls"));
var ComparibleColors_1 = tslib_1.__importDefault(require("./ComparibleColors"));
var GradientControls_1 = tslib_1.__importDefault(require("./GradientControls"));
var prop_types_1 = tslib_1.__importDefault(require("prop-types"));
var defaultColor = constants_1.config.defaultColor, defaultGradient = constants_1.config.defaultGradient;
var Controls = function (_a) {
    var hideEyeDrop = _a.hideEyeDrop, hideAdvancedSliders = _a.hideAdvancedSliders, hideColorGuide = _a.hideColorGuide, hideInputType = _a.hideInputType;
    var _b = (0, context_1.usePicker)(), isGradient = _b.isGradient, onChange = _b.onChange, previousColors = _b.previousColors, previousGraidents = _b.previousGraidents, handleChange = _b.handleChange;
    var _c = (0, react_1.useState)(false), openAdvanced = _c[0], setOpenAdvanced = _c[1];
    var _d = (0, react_1.useState)(false), openComparibles = _d[0], setOpenComparibles = _d[1];
    var _e = (0, react_1.useState)(false), openInputType = _e[0], setOpenInputType = _e[1];
    var noTools = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
    var solidColor = (previousColors === null || previousColors === void 0 ? void 0 : previousColors[0]) || defaultColor;
    var gradientColor = (previousGraidents === null || previousGraidents === void 0 ? void 0 : previousGraidents[0]) || defaultGradient;
    var setSolid = function () {
        onChange(solidColor);
    };
    var setGradient = function () {
        onChange(gradientColor);
    };
    return (react_1.default.createElement("div", { style: { paddingTop: 12, paddingBottom: 9 } },
        react_1.default.createElement("div", { className: 'df jsb ac', style: { width: '100%' } },
            react_1.default.createElement("div", { className: 'df jc ac', style: { height: 28, background: '#e9e9f5', borderRadius: 6, padding: 2 } },
                react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(!isGradient), className: 'control-btn df ac', onClick: setSolid }, "Solid"),
                react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(isGradient), className: 'control-btn df ac', onClick: setGradient }, "Gradient")),
            react_1.default.createElement("div", { className: 'df ac jfe', style: { height: 28, background: '#e9e9f5', borderRadius: 6, padding: 2, display: noTools ? 'none' : '' } },
                !hideEyeDrop && react_1.default.createElement(react_color_eye_dropper_1.default, { onSelect: handleChange, buttonStyle: { width: 30, height: 24, borderRadius: 4, display: 'flex', alignItems: 'center', justifyContent: 'center' } }),
                react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ width: 30 }, (0, exports.controlBtnStyles)(openAdvanced)), { height: 24, borderRadius: 4, display: hideAdvancedSliders ? 'none' : 'flex' }), className: 'jc ac', onClick: function () { return setOpenAdvanced(!openAdvanced); } },
                    react_1.default.createElement(icon_1.SlidersIcon, { color: openAdvanced ? '#568CF5' : '' })),
                react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ width: 30 }, (0, exports.controlBtnStyles)(openComparibles)), { height: 24, borderRadius: 4, display: hideColorGuide ? 'none' : 'flex' }), className: 'jc ac', onClick: function () { return setOpenComparibles(!openComparibles); } },
                    react_1.default.createElement(icon_1.PaletteIcon, { color: openComparibles ? '#568CF5' : '' })),
                react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ width: 30 }, (0, exports.controlBtnStyles)(openInputType)), { height: 24, borderRadius: 4, display: hideInputType ? 'none' : 'flex' }), className: 'jc ac ps-rl', onClick: function () { return setOpenInputType(!openInputType); } },
                    react_1.default.createElement(icon_1.InputsIcon, { color: openInputType ? '#568CF5' : '' }),
                    react_1.default.createElement(InputTypeDropdown, { openInputType: openInputType, setOpenInputType: setOpenInputType })))),
        !hideAdvancedSliders && react_1.default.createElement(AdvancedControls_1.default, { openAdvanced: openAdvanced }),
        !hideColorGuide && react_1.default.createElement(ComparibleColors_1.default, { openComparibles: openComparibles }),
        isGradient && react_1.default.createElement(GradientControls_1.default, null)));
};
exports.default = Controls;
var InputTypeDropdown = function (_a) {
    var openInputType = _a.openInputType, setOpenInputType = _a.setOpenInputType;
    var _b = (0, context_1.usePicker)(), inputType = _b.inputType, setInputType = _b.setInputType;
    var vTrans = openInputType ? 'visibility 0ms linear' : 'visibility 100ms linear 150ms';
    var zTrans = openInputType ? 'z-index 0ms linear' : 'z-index 100ms linear 150ms';
    var oTrans = openInputType ? 'opacity 120ms linear' : 'opacity 150ms linear 50ms';
    var handleInputType = function (e, val) {
        if (openInputType) {
            e.stopPropagation();
            setInputType(val);
            setOpenInputType(false);
        }
    };
    return (react_1.default.createElement("div", { style: { visibility: openInputType ? 'visible' : 'hidden', zIndex: openInputType ? '' : -100, opacity: openInputType ? 1 : 0, transition: "".concat(oTrans, ", ").concat(vTrans, ", ").concat(zTrans) }, className: 'input-dropdown' },
        react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(inputType === 'rgb'), className: 'control-btn df ac ps-rl', onClick: function (e) { return handleInputType(e, 'rgb'); } }, "RGB"),
        react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(inputType === 'hsl'), className: 'control-btn df ac', onClick: function (e) { return handleInputType(e, 'hsl'); } }, "HSL"),
        react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(inputType === 'hsv'), className: 'control-btn df ac', onClick: function (e) { return handleInputType(e, 'hsv'); } }, "HSV"),
        react_1.default.createElement("div", { style: (0, exports.controlBtnStyles)(inputType === 'cmyk'), className: 'control-btn df ac', onClick: function (e) { return handleInputType(e, 'cmyk'); } }, "CMYK")));
};
var controlBtnStyles = function (selected) {
    return {
        background: selected ? 'white' : '',
        color: selected ? '#568CF5' : '',
        boxShadow: selected ? '0px 0px 8px rgba(0,0,0,.125)' : ''
    };
};
exports.controlBtnStyles = controlBtnStyles;
Controls.propTypes = {
    hideEyeDrop: prop_types_1.default.bool,
    hideAdvancedSliders: prop_types_1.default.bool,
    hideColorGuide: prop_types_1.default.bool,
    hideInputType: prop_types_1.default.bool,
};
InputTypeDropdown.propTypes = {
    openInputType: prop_types_1.default.bool,
    setOpenInputType: prop_types_1.default.func,
};
//# sourceMappingURL=Controls.js.map