"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var context_1 = require("./context");
var formatters_1 = require("./formatters");
var Controls_1 = require("./Controls");
var icon_1 = tslib_1.__importStar(require("./icon"));
var GradientControls = function () {
    var gradientType = (0, context_1.usePicker)().gradientType;
    return (react_1.default.createElement("div", { className: 'df jsb', style: { marginTop: 12, marginBottom: -4, background: '#e9e9f5', borderRadius: 6 } },
        react_1.default.createElement(GradientType, null),
        react_1.default.createElement("div", { style: { width: 53 } }, gradientType === 'linear-gradient' && react_1.default.createElement(DegreePicker, null)),
        react_1.default.createElement(StopPicker, null),
        react_1.default.createElement(DeleteBtn, null)));
};
exports.default = GradientControls;
var GradientType = function () {
    var _a = (0, context_1.usePicker)(), gradientType = _a.gradientType, onChange = _a.onChange, value = _a.value;
    var isLinear = gradientType === 'linear-gradient';
    var isRadial = gradientType === 'radial-gradient';
    var handleLinear = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(90deg, ".concat(remaining));
    };
    var handleRadial = function () {
        var remaining = value.split(/,(.+)/)[1];
        onChange("radial-gradient(circle, ".concat(remaining));
    };
    return (react_1.default.createElement("div", { className: 'df ac control-btns-wrap' },
        react_1.default.createElement("div", { className: 'control-btn', onClick: handleLinear, style: tslib_1.__assign({}, (0, Controls_1.controlBtnStyles)(isLinear)) },
            react_1.default.createElement(icon_1.LinearIcon, { color: isLinear ? '#568CF5' : '' })),
        react_1.default.createElement("div", { className: 'control-btn', onClick: handleRadial, style: tslib_1.__assign({}, (0, Controls_1.controlBtnStyles)(isRadial)) },
            react_1.default.createElement(icon_1.RadialIcon, { color: isRadial ? '#568CF5' : '' }))));
};
var StopPicker = function () {
    var _a = (0, context_1.usePicker)(), currentLeft = _a.currentLeft, handleGradient = _a.handleGradient, currentColor = _a.currentColor;
    var handleMove = function (newVal) {
        handleGradient(currentColor, (0, formatters_1.formatInputValues)(newVal, 0, 100));
    };
    return (react_1.default.createElement("div", { className: 'df ac control-btns-wrap', style: { paddingLeft: 8 } },
        react_1.default.createElement(icon_1.StopIcon, null),
        react_1.default.createElement("input", { className: 'degree-input', value: currentLeft, onChange: function (e) { return handleMove(e.target.value); } })));
};
var DegreePicker = function () {
    var _a = (0, context_1.usePicker)(), degrees = _a.degrees, onChange = _a.onChange, value = _a.value;
    var handleDegrees = function (e) {
        var newValue = (0, formatters_1.formatInputValues)(e.target.value, 0, 360);
        var remaining = value.split(/,(.+)/)[1];
        onChange("linear-gradient(".concat(newValue || 0, "deg, ").concat(remaining));
    };
    return (react_1.default.createElement("div", { className: 'ps-rl control-btns-wrap df ac' },
        react_1.default.createElement(icon_1.DegreesIcon, null),
        react_1.default.createElement("input", { className: 'degree-input', value: degrees, onChange: function (e) { return handleDegrees(e); } }),
        react_1.default.createElement("div", { style: { position: 'absolute', right: degrees > 99 ? 0 : degrees < 10 ? 7 : 3, top: 1, fontWeight: 400, fontSize: 13 } }, "\u00B0")));
};
var DeleteBtn = function () {
    var deletePoint = (0, context_1.usePicker)().deletePoint;
    return (react_1.default.createElement("div", { onClick: deletePoint, className: 'df jc ac control-btns-wrap', style: tslib_1.__assign(tslib_1.__assign({ width: 30 }, (0, Controls_1.controlBtnStyles)(false)), { marginRight: 1 }) },
        react_1.default.createElement(icon_1.default, null)));
};
//# sourceMappingURL=GradientControls.js.map