"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var converters_1 = require("./converters");
var formatters_1 = require("./formatters");
var context_1 = require("./context");
var prop_types_1 = tslib_1.__importDefault(require("prop-types"));
var tc = require("tinycolor2");
var Inputs = function () {
    var _a = (0, react_1.useState)(''), disable = _a[0], setDisable = _a[1];
    var _b = (0, context_1.usePicker)(), handleChange = _b.handleChange, tinyColor = _b.tinyColor, r = _b.r, g = _b.g, b = _b.b, opacity = _b.opacity, inputType = _b.inputType;
    var hex = tinyColor.toHex();
    var _c = (0, react_1.useState)(hex), newHex = _c[0], setNewHex = _c[1];
    (0, react_1.useEffect)(function () {
        if (disable !== 'hex') {
            setNewHex(hex);
        }
    }, [tinyColor, disable, hex]);
    var handleHex = function (e) {
        var tinyHex = tc(e.target.value);
        setNewHex(e.target.value);
        if (tinyHex.isValid()) {
            var _a = tinyHex.toRgb(), r_1 = _a.r, g_1 = _a.g, b_1 = _a.b;
            var newColor = "rgba(".concat(r_1, ", ").concat(g_1, ", ").concat(b_1, ", ").concat(opacity, ")");
            handleChange(newColor);
        }
    };
    return (react_1.default.createElement("div", { style: { display: 'flex', justifyContent: 'space-between', paddingTop: 14 } },
        react_1.default.createElement("div", { style: { width: 74 } },
            react_1.default.createElement("input", { className: 'input-wrap', value: newHex, onChange: function (e) { return handleHex(e); }, onFocus: function () { return setDisable('hex'); }, onBlur: function () { return setDisable(''); } }),
            react_1.default.createElement("div", { className: 'input-label' }, "HEX")),
        inputType === 'hsl' && react_1.default.createElement(HSLInputs, null),
        inputType === 'rgb' && react_1.default.createElement(RGBInputs, null),
        inputType === 'hsv' && react_1.default.createElement(HSVInputs, null),
        inputType === 'cmyk' && react_1.default.createElement(CMKYInputs, null),
        react_1.default.createElement(Input, { value: opacity * 100, callback: function (newVal) { return handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(newVal / 100, ")")); }, label: 'A' })));
};
exports.default = Inputs;
var RGBInputs = function () {
    var _a = (0, context_1.usePicker)(), handleChange = _a.handleChange, r = _a.r, g = _a.g, b = _a.b, opacity = _a.opacity;
    var handleRgb = function (_a) {
        var r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Input, { value: r, callback: function (newVal) { return handleRgb({ r: newVal, g: g, b: b }); }, label: 'R', max: 255 }),
        react_1.default.createElement(Input, { value: g, callback: function (newVal) { return handleRgb({ r: r, g: newVal, b: b }); }, label: 'G', max: 255 }),
        react_1.default.createElement(Input, { value: b, callback: function (newVal) { return handleRgb({ r: r, g: g, b: newVal }); }, label: 'B', max: 255 })));
};
var HSLInputs = function () {
    var _a = (0, context_1.usePicker)(), handleChange = _a.handleChange, s = _a.s, l = _a.l, internalHue = _a.internalHue, opacity = _a.opacity, setInternalHue = _a.setInternalHue;
    var handleH = function (h, s, l) {
        setInternalHue(h);
        var _a = tc({ h: h, s: s, l: l }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    var handleSl = function (value) {
        var _a = tc(value).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Input, { value: round(internalHue), callback: function (newVal) { return handleH(newVal, s, l); }, label: 'H', max: 360 }),
        react_1.default.createElement(Input, { value: round(s * 100), callback: function (newVal) { return handleSl({ h: internalHue, s: newVal, l: l }); }, label: 'S' }),
        react_1.default.createElement(Input, { value: round(l * 100), callback: function (newVal) { return handleSl({ h: internalHue, s: s, l: newVal }); }, label: 'L' })));
};
var HSVInputs = function () {
    var _a = (0, context_1.usePicker)(), handleChange = _a.handleChange, hsvS = _a.hsvS, hsvV = _a.hsvV, internalHue = _a.internalHue, setInternalHue = _a.setInternalHue, opacity = _a.opacity;
    var handleH = function (h, s, v) {
        setInternalHue(h);
        var _a = tc({ h: h, s: s, v: v }).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    var handleSV = function (value) {
        var _a = tc(value).toRgb(), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Input, { value: round(internalHue), callback: function (newVal) { return handleH(newVal, hsvS, hsvV); }, label: 'H', max: 360 }),
        react_1.default.createElement(Input, { value: round(hsvS * 100), callback: function (newVal) { return handleSV({ h: internalHue, s: newVal, v: hsvV }); }, label: 'S' }),
        react_1.default.createElement(Input, { value: round(hsvV * 100), callback: function (newVal) { return handleSV({ h: internalHue, s: hsvS, v: newVal }); }, label: 'V' })));
};
var CMKYInputs = function () {
    var _a = (0, context_1.usePicker)(), handleChange = _a.handleChange, r = _a.r, g = _a.g, b = _a.b, opacity = _a.opacity;
    var _b = (0, converters_1.rgb2cmyk)(r, g, b), c = _b.c, m = _b.m, k = _b.k, y = _b.y;
    var handleCmyk = function (value) {
        var _a = (0, converters_1.cmykToRgb)(value), r = _a.r, g = _a.g, b = _a.b;
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", ").concat(opacity, ")"));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Input, { value: round(c * 100), callback: function (newVal) { return handleCmyk({ c: newVal, m: m, y: y, k: k }); }, label: 'C' }),
        react_1.default.createElement(Input, { value: round(m * 100), callback: function (newVal) { return handleCmyk({ c: c, m: newVal, y: y, k: k }); }, label: 'M' }),
        react_1.default.createElement(Input, { value: round(y * 100), callback: function (newVal) { return handleCmyk({ c: c, m: m, y: newVal, k: k }); }, label: 'Y' }),
        react_1.default.createElement(Input, { value: round(k * 100), callback: function (newVal) { return handleCmyk({ c: c, m: m, y: y, k: newVal }); }, label: 'K' })));
};
var Input = function (_a) {
    var value = _a.value, callback = _a.callback, _b = _a.max, max = _b === void 0 ? 100 : _b, label = _a.label;
    var _c = (0, react_1.useState)(value), temp = _c[0], setTemp = _c[1];
    var inputType = (0, context_1.usePicker)().inputType;
    (0, react_1.useEffect)(function () {
        setTemp(value);
    }, [value]);
    var onChange = function (e) {
        var newVal = (0, formatters_1.formatInputValues)(parseFloat(e.target.value), 0, max);
        setTemp(newVal);
        callback(newVal);
    };
    return (react_1.default.createElement("div", { style: { width: inputType === 'cmyk' ? 40 : 44 } },
        react_1.default.createElement("input", { className: 'input-wrap', value: temp, onChange: function (e) { return onChange(e); } }),
        react_1.default.createElement("div", { className: 'input-label' }, label)));
};
var round = function (val) {
    return Math.round(val, 2);
};
Input.propTypes = {
    value: prop_types_1.default.oneOfType([prop_types_1.default.string, prop_types_1.default.number]),
    callback: prop_types_1.default.func,
    max: prop_types_1.default.number,
    label: prop_types_1.default.string,
};
//# sourceMappingURL=Inputs.js.map